AC_DEFUN([AC_SEARCH_QWT4],
[
     ac_with_Qwt4=no


    ac_search_libs="Qwt5 Qwt47 Qwt46 Qwt qwt-qt4 qwt"
    case "${host}" in
      *-mingw32*)
        ac_search_lib_path="/usr/i686-pc-mingw32/sys-root/mingw/lib"
        ac_search_include_path="/usr/i686-pc-mingw32/sys-root/mingw/include/qwt"
        ;;
      *)
        if test "${build_cpu}" = "x86_64"; then
           ac_search_lib_path="$INSROOT/lib64 $QT4DIR/lib64 /usr/lib64/qt47/lib64 /usr/lib64/qt46/lib64 /usr/lib64/qt4/lib /usr/lib64 /usr/local/lib64/qt4  /opt/local/lib64/qt4 /usr/lib/qt4 /usr/lib"
        else
           ac_search_lib_path="$INSROOT/lib $QT4DIR/lib /usr/lib/qt47/lib /usr/lib/qt46/lib /usr/lib/qt4/lib /usr/lib /usr/local/lib/qt4  /opt/local/lib/qt4 /usr/lib/qt4"
        fi
        ac_search_include_path="$INSROOT/include $QT4DIR/include /usr/include/qwt5 /usr/include /usr/lib64/qt47/include /usr/lib/qt47/include /usr/lib64/qt46/include /usr/lib/qt46/include /usr/lib64/qt4/include /usr/lib/qt4/include /usr/include/qwt-qt4 /usr/include/qwt /usr/local/include/qt4  /opt/local/include/qt4 /usr/include/qt4"
        ;;
   esac

     AC_ARG_WITH(Qwt4,
          AC_HELP_STRING([--with-Qwt4=DIR], [root directory of Qwt4 installation]),
          ac_with_Qwt4=$withval
          if test "x${ac_with_Qwt4}" != xyes && test "x${ac_with_Qwt4}" != xno; then
               ac_Qwt4_include="-I$withval/include"
               if test "${build_cpu}" = "x86_64"; then
                  ac_Qwt4_libdir="-L$withval/lib64"
               else
                  ac_Qwt4_libdir="-L$withval/lib"
               fi
          fi
     )

     AC_ARG_WITH([Qwt4-include-dir],
          AC_HELP_STRING([--with-Qwt4-include-dir=DIR], [Qwt4 header files are in DIR]),
          ac_with_Qwt4=$withval
          if test "x${ac_with_Qwt4}" != xyes && test "x${ac_with_Qwt4}" != xno; then
               ac_Qwt4_include="$withval"
          fi
     )

     AC_ARG_WITH([Qwt4-lib-dir],
          AC_HELP_STRING([--with-Qwt4-lib-dir=DIR], [The Qwt4 library is in DIR]),
          ac_with_Qwt4=$withval
          if test "x${ac_with_Qwt4}" != xyes && test "x${ac_with_Qwt4}" != xno; then
               ac_Qwt4_libdir="$withval"
          fi
     )

     AC_ARG_WITH([Qwt4-lib-name],
          AC_HELP_STRING([--with-Qwt4-lib-name=DIR], [The Qwt4 library name, e.g. qwt, Qwt]),
          ac_with_Qwt4=$withval
          if test "x${ac_with_Qwt4}" != xyes && test "x${ac_with_Qwt4}" != xno; then
               ac_Qwt4_libs="-l$withval"
          fi
     )

  if test "x${ac_Qwt4_libdir}" == "x"; then
    for ac_qwt4_path_test in $ac_search_lib_path ; do
dnl      AC_MSG_NOTICE(Check for lib path $ac_qwt4_path_test/)
      if test -r "$ac_qwt4_path_test/"; then
         for ac_qt_lib_test in $ac_search_libs ; do
dnl            AC_MSG_NOTICE( Check for lib $ac_qwt4_path_test/lib$ac_qt_lib_test.*)
            ls $ac_qwt4_path_test/*$ac_qt_lib_test.*  >/dev/null 2>&1
            if test $? -eq 0; then
dnl              AC_MSG_NOTICE(Found it!)
	      ac_Qwt4_libdir="-L$ac_qwt4_path_test"
	      ac_Qwt4_libs="-l$ac_qt_lib_test"
              break;
	    fi
         done
         if test "$ac_Qwt4_libs"; then
            break;
         fi
      fi
    done
    ls $ac_Qwt4_libdir/libQwt*.la >/dev/null 2>&1
    if test $? -eq 0 && test x`echo $build_os |sed "s/darwin.*/darwin/"` = "xdarwin"; then
	AC_WARN(Please remove all *.la files from directory $ac_Qwt4_libdir. Otherwise Qwt application will not work!)
    fi
  fi



   if test "x${ac_Qwt4_include}" == "x"; then
    for ac_qt_path_test in $ac_search_include_path ; do
dnl      AC_MSG_NOTICE(Check for include path $ac_qt_path_test/qwt.h)
      if test -r "$ac_qt_path_test/qwt.h"; then
         ac_Qwt4_include="-I$ac_qt_path_test"
         break;
      fi
    done
   fi

    AC_SEARCH_QWT4_LOCAL($ac_Qwt4_libdir, $ac_Qwt4_include, $ac_Qwt4_libs)
])


# subfunction for easier reuse
AC_DEFUN([AC_SEARCH_QWT4_LOCAL],
[
     OLD_LDFLAGS=$LDFLAGS
     OLD_CXXFLAGS=$CXXFLAGS
     OLD_LIBS=$LIBS

     if test "x$QT4_LIBS" == "x"; then
         AC_SEARCH_QT4
     fi

#     AC_MSG_NOTICE($QT4_CXXFLAGS $QT4_LDFLAGS $QT4_LIBS)
#     AC_MSG_NOTICE($1 : $2 : $3)

     if test "$1"; then
          LDFLAGS="$LDFLAGS $QT4_LDFLAGS $1"
     fi
     if test "$2"; then
          CXXFLAGS="$CXXFLAGS $2 $QT4_CXXFLAGS"
     fi
     if test "$3"; then
          LIBS="$3 $QT4_LIBS"
     fi

     AC_LANG_PUSH(C++)
     AC_MSG_CHECKING(for Qwt4 in $1 in $2 in $3)
     AC_TRY_LINK([
          #include <qwt.h>
     ],[
          ;
     ],[
     success=yes
     ],[
     success=no
     ])
     AC_MSG_RESULT($success)
     AC_LANG_POP()


     LDFLAGS=$OLD_LDFLAGS
     CXXFLAGS=$OLD_CXXFLAGS
     LIBS=$OLD_LIBS
     AM_CONDITIONAL(HAVE_QWT4, true)

     if test "x$success" != xyes; then
          AC_MSG_ERROR(Qwt4 not (properly) installed. Get a (free) recent version from: http://qwt.sourceforge.net/)
     else
          if test "$1"; then
               AC_SUBST(QWT4_LDFLAGS, "$1")
          fi
          if test "$2"; then
               AC_SUBST(QWT4_CXXFLAGS, "$2")
          fi
	  if test "$3"; then
	       AC_SUBST(QWT4_LIBS, "$3")
	  fi
     fi

])
